"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonPatch = void 0;
const op_1 = require("../../json-patch/op");
const JsonPatchDraft_1 = require("./JsonPatchDraft");
class JsonPatch {
    constructor(model) {
        this.model = model;
    }
    createDraft(ops) {
        const draft = new JsonPatchDraft_1.JsonPatchDraft(this.model);
        draft.applyOps(ops);
        return draft;
    }
    createCrdtPatch(ops) {
        return this.createDraft(ops).patch(this.model.clock);
    }
    applyPatch(jsonPatch) {
        const ops = jsonPatch.map(op_1.operationToOp);
        const patch = this.createCrdtPatch(ops);
        this.model.clock.tick(patch.span());
        this.model.applyPatch(patch);
    }
}
exports.JsonPatch = JsonPatch;
